import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/*
 * Ghassan Fakher
 * section 4
 * gkf01
 */
public class CodeGenerator {
	private static Variable[] variables;	//I made the variables static to avoid writing the arguments in every single method.
	private static PrintStream code;
	private static Scanner scan;
	private static String className;
	private static int currentPos;
	public static void main(String[] args) throws FileNotFoundException
	{
		File input = new File("Student.txt");
		scan = new Scanner(input);
		int fileLength = checkFile();
		variables = new Variable[fileLength - 1];
		scan = new Scanner(input);
		className = scan.next();
		variables = fillVariables();
		code = new PrintStream("Student.java");
		generateCode(variables, className);
	}
	// the method that does everything related to generating the desired code
	public static void generateCode(Variable[] variables, String className) throws FileNotFoundException
	{ 
		printClassName();
		printVariables();
		generateConstructor();
		generateCopyConstructor();
		generateGettersAndSetters();
		generateToString();
	}
	public static void generateToString()
	{
		code.println("\t" + "/**"); 
		code.println("\t" + "* Returns a " + " string" + " object representing this " + className + " value.");
		code.println("\t" + "* The result is a string of 2 line(s) where each line is in turn");
		code.println("\t" + "* the string representation of the corresponding instance field.");
		code.println("\t" + "* @return a string representation of this object");
		code.println("\t" + "*/");
		code.println("\t" + "public String toString() {");
		code.println("\t" + "\t" + "String s = " + "\"" + "\"" + ";");
		for(int i = 0; i < variables.length; i++)
		{
			code.println("\t" + "\t" + "s += " + "\"" + variables[i].getVariable() + " = " + "\"" + " + " + variables[i].getVariable() + ";");	//in order to improve the output
		}
		code.println("\t" + "\t" + "return s;");
		code.println("\t" + "}");
		code.println("}");
	}
	public static void generateGettersAndSetters()
	{
		for(int i = 0; i < variables.length; i++)
		{
			currentPos = i;
			generateGetters();
			generateSetters();
		}
	}
	public static void generateSetters()
	{
		code.println("\t" + "/**" + "\n" + "\t" + "* Mutator method to set the " + variables[currentPos].getVariable() + " of the " + className); 
		code.println("\t" + "* @param " + variables[currentPos].getType() + " the value of type " + variables[currentPos].getType() + " representing the " + variables[currentPos].getType() + " of the " + className);
		code.println("\t" + "*/");
		code.println("\t" + "public " + " void set" + variables[currentPos].getVariable().substring(0, 1).toUpperCase() + variables[currentPos].getVariable().substring(1, variables[currentPos].getVariable().length()) + "(" + variables[currentPos].getType() + " " + variables[currentPos].getVariable() + ")" +"{");
		code.println("\t" + "\t" + "this." + variables[currentPos].getVariable() + " = " + variables[currentPos].getVariable() + ";");
		code.println("\t" + "}");
	}
	public static void generateGetters()
	{
		code.println("\t" + "/**"); 
		code.println("\t" + "* Returns the " + variables[currentPos].getVariable() + " of the " + className);
		code.println("\t" + "* @return the value of type " + variables[currentPos].getType() + " representing the name of the " + className);
		code.println("\t" + "*/");
		code.println("\t" + "public " + variables[currentPos].getType() + " get" + variables[currentPos].getVariable().substring(0, 1).toUpperCase() + variables[currentPos].getVariable().substring(1, variables[currentPos].getVariable().length()) + "() {");
		code.println("\t" + "\t" + "return " + variables[currentPos].getVariable() + ";");
		code.println("\t" + "}");
	}
	public static void generateCopyConstructor()
	{
		code.println("\t" + "/**"); 
		code.println("\t" + "* Copy Constructor");
		code.println("\t" + "*/");
		String objectName = "s";
		code.println("\t" + "public " + className + "(" + className + " " + objectName + ")" + " {");
		for(int i = 0; i < variables.length; i++)
		{
			code.println("\t" + "\t" +"this." + variables[i].getVariable() + " = " + objectName + "." + variables[i].getVariable() + ";");
		}
		code.println("\t" + "}");
	}
	public static void generateConstructor()
	{
		code.println("\t" + "/**");
		code.println("\t" + "* Constructor for objects of class " + className);
		code.println("\t" + "*/");
		code.println("\t" +"public " + className + "() {");
		code.println("\t" + "}");
	}
	public static void printVariables()
	{
		for(int i = 0; i < variables.length; i++)
		{
			code.println("\t" + "private " + variables[i].getType() + " " + variables[i].getVariable() + ";");
		}
	}
	public static void printClassName()
	{
		code.println("public class " + className + " {");
	}
	public static Variable[] fillVariables()
	{
		for(int i = 0; i < variables.length; i++)
		{
			variables[i] = new Variable(scan.next(), scan.next());
		}
		return variables;
	}
	public static int checkFile()
	{
		int fileLength = 0;
		while(scan.hasNextLine())
		{
			scan.nextLine();
			fileLength++;
		}
		return fileLength;
	}
}
